"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _store = _interopRequireDefault(require("store/dist/store.modern"));

var _ApolloClient = require("../apollo/ApolloClient");

var _mutations = require("./graphql/mutations");

var _queries = require("./graphql/queries");

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Checkout = function Checkout(config) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, Checkout);
  (0, _defineProperty2["default"])(this, "initCheckout",
  /*#__PURE__*/
  function () {
    var _ref = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var presentmentCurrencyCode,
          _checkout,
          _ref2,
          checkout,
          _args = arguments;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              presentmentCurrencyCode = _args.length > 0 && _args[0] !== undefined ? _args[0] : "AUD";

              if (!((0, _utils.isBrowser)() && (0, _utils.savedCheckoutExists)())) {
                _context.next = 14;
                break;
              }

              _context.prev = 2;
              _context.next = 5;
              return _this.getCheckout();

            case 5:
              _checkout = _context.sent;

              if (_checkout.completedAt) {
                _context.next = 9;
                break;
              }

              _this.setCheckout(_checkout);

              return _context.abrupt("return", _this);

            case 9:
              _context.next = 14;
              break;

            case 11:
              _context.prev = 11;
              _context.t0 = _context["catch"](2);
              console.error(_context.t0);

            case 14:
              _context.next = 16;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_CREATE,
                variables: {
                  input: {
                    presentmentCurrencyCode: presentmentCurrencyCode
                  }
                }
              });

            case 16:
              _ref2 = _context.sent;
              checkout = _ref2.data.checkoutCreate.checkout;

              _this.setCheckout(checkout);

              return _context.abrupt("return", _this);

            case 20:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[2, 11]]);
    }));

    return function () {
      return _ref.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "duplicateCheckout",
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2() {
      var _ref5, _lineItems$edges;

      var changes,
          _ref4,
          currencyCode,
          customAttributes,
          lineItems,
          note,
          shippingAddress,
          _ref6,
          checkout,
          discountCodes,
          _iteratorNormalCompletion,
          _didIteratorError,
          _iteratorError,
          _iterator,
          _step,
          discountCode,
          _args2 = arguments;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              changes = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : {};
              _context2.next = 3;
              return _this.getCheckout();

            case 3:
              _context2.t1 = _ref5 = _context2.sent;
              _context2.t0 = _context2.t1 !== null;

              if (!_context2.t0) {
                _context2.next = 7;
                break;
              }

              _context2.t0 = _ref5 !== void 0;

            case 7:
              if (!_context2.t0) {
                _context2.next = 11;
                break;
              }

              _context2.t2 = _ref5;
              _context2.next = 12;
              break;

            case 11:
              _context2.t2 = {};

            case 12:
              _ref4 = _context2.t2;
              currencyCode = _ref4.currencyCode;
              customAttributes = _ref4.customAttributes;
              lineItems = _ref4.lineItems;
              note = _ref4.note;
              shippingAddress = _ref4.shippingAddress;
              _context2.next = 20;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_CREATE,
                variables: {
                  input: _objectSpread({
                    customAttributes: customAttributes,
                    lineItems: lineItems === null || lineItems === void 0 ? void 0 : (_lineItems$edges = lineItems.edges) === null || _lineItems$edges === void 0 ? void 0 : _lineItems$edges.map(function (edge) {
                      var _ref7;

                      return _ref7 = {
                        variantId: edge.node.variant.id,
                        quantity: edge.node.quantity
                      }, (0, _defineProperty2["default"])(_ref7, "quantity", edge.node.quantity), (0, _defineProperty2["default"])(_ref7, "customAttributes", edge.node.customAttributes), _ref7;
                    }),
                    note: note,
                    presentmentCurrencyCode: currencyCode,
                    shippingAddress: shippingAddress ? {
                      address1: shippingAddress.address1,
                      address2: shippingAddress.address2,
                      city: shippingAddress.city,
                      company: shippingAddress.company,
                      country: shippingAddress.country,
                      firstName: shippingAddress.firstName,
                      lastName: shippingAddress.lastName,
                      phone: shippingAddress.phone,
                      province: shippingAddress.province,
                      zip: shippingAddress.zip
                    } : undefined
                  }, changes)
                }
              });

            case 20:
              _ref6 = _context2.sent;
              checkout = _ref6.data.checkoutCreate.checkout;

              _this.setCheckout(checkout);

              discountCodes = _store["default"].get("next:checkout_discount_codes") || "[]";
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context2.prev = 27;
              _iterator = discountCodes[Symbol.iterator]();

            case 29:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context2.next = 36;
                break;
              }

              discountCode = _step.value;
              _context2.next = 33;
              return _this.applyDiscountCode(discountCode);

            case 33:
              _iteratorNormalCompletion = true;
              _context2.next = 29;
              break;

            case 36:
              _context2.next = 42;
              break;

            case 38:
              _context2.prev = 38;
              _context2.t3 = _context2["catch"](27);
              _didIteratorError = true;
              _iteratorError = _context2.t3;

            case 42:
              _context2.prev = 42;
              _context2.prev = 43;

              if (!_iteratorNormalCompletion && _iterator["return"] != null) {
                _iterator["return"]();
              }

            case 45:
              _context2.prev = 45;

              if (!_didIteratorError) {
                _context2.next = 48;
                break;
              }

              throw _iteratorError;

            case 48:
              return _context2.finish(45);

            case 49:
              return _context2.finish(42);

            case 50:
              return _context2.abrupt("return", _this);

            case 51:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[27, 38, 42, 50], [43,, 45, 49]]);
    }));

    return function () {
      return _ref3.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "setCheckout", function (checkout) {
    _store["default"].set("next:checkout_id", checkout.id);

    _this.checkout = _objectSpread({}, checkout, {
      lineItems: checkout.lineItems.edges.map(function (_ref8) {
        var node = _ref8.node;
        return _objectSpread({}, node);
      })
    });
  });
  (0, _defineProperty2["default"])(this, "getCheckout",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee3() {
    var _res$data, checkoutId, res, node;

    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            checkoutId = _store["default"].get("next:checkout_id");
            _context3.next = 4;
            return _this.client.query({
              query: _queries.FETCH_CHECKOUT,
              fetchPolicy: "no-cache",
              variables: {
                checkoutId: checkoutId
              }
            });

          case 4:
            res = _context3.sent;
            node = !(res === null || res === void 0 ? void 0 : (_res$data = res.data) === null || _res$data === void 0 ? void 0 : _res$data.node) ? {} : res.data.node;

            _this.setCheckout(node);

            return _context3.abrupt("return", node);

          case 10:
            _context3.prev = 10;
            _context3.t0 = _context3["catch"](0);
            console.error(_context3.t0);

          case 13:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[0, 10]]);
  })));
  (0, _defineProperty2["default"])(this, "addToCart",
  /*#__PURE__*/
  function () {
    var _ref10 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(variantId) {
      var quantity,
          customAttributes,
          found,
          lineItems,
          _ref13,
          checkout,
          _args4 = arguments;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              quantity = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : 1;
              customAttributes = _args4.length > 2 ? _args4[2] : undefined;
              found = false;
              lineItems = _this.checkout.lineItems.map(function (lineItem) {
                if (lineItem.variant.id === variantId) {
                  found = true;
                  return {
                    customAttributes: [].concat((0, _toConsumableArray2["default"])(lineItem.customAttributes.map(function (_ref11) {
                      var key = _ref11.key,
                          value = _ref11.value;
                      return {
                        key: key,
                        value: value
                      };
                    })), (0, _toConsumableArray2["default"])(customAttributes)),
                    quantity: lineItem.quantity + quantity,
                    variantId: variantId
                  };
                }

                return {
                  customAttributes: lineItem.customAttributes.map(function (_ref12) {
                    var key = _ref12.key,
                        value = _ref12.value;
                    return {
                      key: key,
                      value: value
                    };
                  }),
                  quantity: lineItem.quantity,
                  variantId: lineItem.variant.id
                };
              });
              _context4.next = 6;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_LINE_ITEMS_REPLACE,
                variables: {
                  checkoutId: _this.checkout.id,
                  lineItems: (0, _toConsumableArray2["default"])(found ? lineItems : [].concat((0, _toConsumableArray2["default"])(lineItems), [{
                    quantity: quantity,
                    variantId: variantId,
                    customAttributes: customAttributes
                  }]))
                }
              });

            case 6:
              _ref13 = _context4.sent;
              checkout = _ref13.data.checkoutLineItemsReplace.checkout;

              _this.setCheckout(checkout);

              return _context4.abrupt("return", _this);

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x) {
      return _ref10.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "removeFromCart",
  /*#__PURE__*/
  function () {
    var _ref14 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5(variantId) {
      var lineItems, _ref16, checkout;

      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              lineItems = _this.checkout.lineItems.map(function (lineItem) {
                if (lineItem.variant.id === variantId) {
                  return false;
                }

                return _objectSpread({}, lineItem.customAttributes && {
                  customAttributes: lineItem.customAttributes.map(function (_ref15) {
                    var key = _ref15.key,
                        value = _ref15.value;
                    return {
                      key: key,
                      value: value
                    };
                  })
                }, {
                  quantity: lineItem.quantity,
                  variantId: lineItem.variant.id
                });
              }).filter(Boolean);
              _context5.next = 3;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_LINE_ITEMS_REPLACE,
                variables: {
                  checkoutId: _this.checkout.id,
                  lineItems: lineItems
                }
              });

            case 3:
              _ref16 = _context5.sent;
              checkout = _ref16.data.checkoutLineItemsReplace.checkout;

              _this.setCheckout(checkout);

              return _context5.abrupt("return", _this);

            case 7:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function (_x2) {
      return _ref14.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "updateCartItem",
  /*#__PURE__*/
  function () {
    var _ref17 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee6(variantId, quantity, customAttributes) {
      var lineItems, _ref20, checkout;

      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              lineItems = _this.checkout.lineItems.map(function (lineItem) {
                if (lineItem.variant.id === variantId) {
                  return _objectSpread({}, lineItem.customAttributes && {
                    customAttributes: [].concat((0, _toConsumableArray2["default"])(lineItem.customAttributes.map(function (_ref18) {
                      var key = _ref18.key,
                          value = _ref18.value;
                      return {
                        key: key,
                        value: value
                      };
                    })), (0, _toConsumableArray2["default"])(customAttributes))
                  }, {
                    variantId: variantId,
                    quantity: quantity
                  });
                }

                return _objectSpread({}, lineItem.customAttributes && {
                  customAttributes: lineItem.customAttributes.map(function (_ref19) {
                    var key = _ref19.key,
                        value = _ref19.value;
                    return {
                      key: key,
                      value: value
                    };
                  })
                }, {
                  quantity: lineItem.quantity,
                  variantId: lineItem.variant.id
                });
              });
              _context6.next = 3;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_LINE_ITEMS_REPLACE,
                variables: {
                  checkoutId: _this.checkout.id,
                  lineItems: lineItems
                }
              });

            case 3:
              _ref20 = _context6.sent;
              checkout = _ref20.data.checkoutLineItemsReplace.checkout;

              _this.setCheckout(checkout);

              return _context6.abrupt("return", _this);

            case 7:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function (_x3, _x4, _x5) {
      return _ref17.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "clearCart",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee7() {
    var _ref22, checkout;

    return _regenerator["default"].wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            _context7.next = 2;
            return _this.client.mutate({
              mutation: _mutations.CHECKOUT_LINE_ITEMS_REPLACE,
              variables: {
                checkoutId: _this.checkout.id,
                lineItems: []
              }
            });

          case 2:
            _ref22 = _context7.sent;
            checkout = _ref22.data.checkoutLineItemsReplace.checkout;

            _this.setCheckout(checkout);

            return _context7.abrupt("return", _this);

          case 6:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  })));
  (0, _defineProperty2["default"])(this, "updateAttributes",
  /*#__PURE__*/
  function () {
    var _ref23 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee8(input) {
      var _ref24, checkout;

      return _regenerator["default"].wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              _context8.next = 2;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_ATTRIBUTES_UPDATE,
                variables: {
                  checkoutId: _this.checkout.id,
                  input: input
                }
              });

            case 2:
              _ref24 = _context8.sent;
              checkout = _ref24.data.checkoutAttributesUpdateV2.checkout;

              _this.setCheckout(checkout);

              return _context8.abrupt("return", _this);

            case 6:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));

    return function (_x6) {
      return _ref23.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "updateShippingAddress",
  /*#__PURE__*/
  function () {
    var _ref25 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee9(input) {
      var _ref26, checkout;

      return _regenerator["default"].wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              _context9.next = 2;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_SHIPPING_ADDRESS_UPDATE,
                variables: {
                  checkoutId: _this.checkout.id,
                  shippingAddress: {
                    firstName: input.firstName,
                    lastName: input.lastName,
                    address1: input.address1,
                    address2: input.address2,
                    city: input.city,
                    country: input.country,
                    phone: input.phone,
                    province: input.province,
                    zip: input.zip
                  }
                }
              });

            case 2:
              _ref26 = _context9.sent;
              checkout = _ref26.data.checkoutShippingAddressUpdateV2.checkout;

              _this.setCheckout(checkout);

              return _context9.abrupt("return", _this);

            case 6:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    return function (_x7) {
      return _ref25.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "updateEmail",
  /*#__PURE__*/
  function () {
    var _ref27 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee10(input) {
      var _ref28, checkout;

      return _regenerator["default"].wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _context10.next = 2;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_EMAIL_UPDATE,
                variables: {
                  checkoutId: _this.checkout.id,
                  email: input
                }
              });

            case 2:
              _ref28 = _context10.sent;
              checkout = _ref28.data.checkoutEmailUpdateV2.checkout;

              _this.setCheckout(checkout);

              return _context10.abrupt("return", _this);

            case 6:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));

    return function (_x8) {
      return _ref27.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "updateCurrency",
  /*#__PURE__*/
  function () {
    var _ref29 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee11(presentmentCurrencyCode) {
      return _regenerator["default"].wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              _context11.next = 2;
              return _this.duplicateCheckout({
                presentmentCurrencyCode: presentmentCurrencyCode
              });

            case 2:
              return _context11.abrupt("return", _this);

            case 3:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));

    return function (_x9) {
      return _ref29.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "checkoutCustomerAssociate",
  /*#__PURE__*/
  function () {
    var _ref30 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee12(accessToken) {
      var _ref31, checkout;

      return _regenerator["default"].wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              _context12.next = 2;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_CUSTOMER_ASSOCIATE,
                variables: {
                  checkoutId: _this.checkout.id,
                  customerAccessToken: accessToken
                }
              });

            case 2:
              _ref31 = _context12.sent;
              checkout = _ref31.data.checkoutCustomerAssociateV2.checkout;

              _this.setCheckout(checkout);

              return _context12.abrupt("return", _this);

            case 6:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));

    return function (_x10) {
      return _ref30.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "applyDiscountCode",
  /*#__PURE__*/
  function () {
    var _ref32 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee13(discountCode) {
      var _ref33, data, discountCodes;

      return _regenerator["default"].wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              _context13.next = 2;
              return _this.client.mutate({
                mutation: _mutations.CHECKOUT_DISCOUNT_APPLY,
                variables: {
                  discountCode: discountCode,
                  checkoutId: _this.checkout.id
                }
              });

            case 2:
              _ref33 = _context13.sent;
              data = _ref33.data.checkoutDiscountCodeApplyV2;

              if (data.checkoutUserErrors.length) {
                _context13.next = 11;
                break;
              }

              _this.setCheckout(data.checkout); // Update localstorage with new discount codes - used during checkout duplication


              discountCodes = _store["default"].get("next:checkout_discount_codes") || [];

              _store["default"].set("next:checkout_discount_codes", [].concat((0, _toConsumableArray2["default"])(discountCodes), [discountCode]).filter(function (value, index, self) {
                return self.indexOf(value) === index;
              }));

              return _context13.abrupt("return", _this);

            case 11:
              return _context13.abrupt("return", data);

            case 12:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    }));

    return function (_x11) {
      return _ref32.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "getShippingRates",
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee14() {
    var _ref35, node;

    return _regenerator["default"].wrap(function _callee14$(_context14) {
      while (1) {
        switch (_context14.prev = _context14.next) {
          case 0:
            _context14.next = 2;
            return _this.client.query({
              query: _queries.FETCH_SHIPPING_RATES,
              variables: {
                id: _this.checkout.id
              }
            });

          case 2:
            _ref35 = _context14.sent;
            node = _ref35.data.node;

            _this.setCheckout(node);

            return _context14.abrupt("return", node);

          case 6:
          case "end":
            return _context14.stop();
        }
      }
    }, _callee14);
  })));
  var client = (0, _ApolloClient.createApolloClient)({
    uri: "https://".concat(config.shopName, ".myshopify.com/api/").concat(config.version ? "".concat(config.version, "/") : "", "graphql.json"),
    headers: {
      "X-Shopify-Storefront-Access-Token": config.accessToken
    }
  });
  this.client = client;
}
/**
 * Initialize checkout
 */
;

var _default = Checkout;
exports["default"] = _default;