"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CheckoutContext = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _checkout = _interopRequireDefault(require("./checkout"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var defaultValues = {
  checkout: {
    lineItems: []
  }
};

var CheckoutContext = _react["default"].createContext(null);

exports.CheckoutContext = CheckoutContext;

var CheckoutProvider = function CheckoutProvider(_ref) {
  var children = _ref.children,
      shopName = _ref.shopName,
      accessToken = _ref.accessToken,
      apiVersion = _ref.apiVersion;

  var _useState = (0, _react.useState)(defaultValues.checkout),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      checkout = _useState2[0],
      setCheckout = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
      isLoading = _useState4[0],
      setLoading = _useState4[1];

  var _useState5 = (0, _react.useState)(null),
      _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
      checkoutClient = _useState6[0],
      setCheckoutClient = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
      checkoutInitialised = _useState8[0],
      setCheckoutInitialised = _useState8[1];

  (0, _react.useEffect)(function () {
    var client = new _checkout["default"]({
      shopName: shopName,
      accessToken: accessToken,
      version: apiVersion
    });
    setCheckoutClient(client);
  }, []);
  (0, _react.useEffect)(function () {
    if (checkoutClient) {
      initializeCheckout();
    }
  }, [checkoutClient]);

  var initializeCheckout =
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee() {
      var client;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return checkoutClient.initCheckout();

            case 2:
              client = _context.sent;
              setCheckout(client.checkout);
              setCheckoutInitialised(true);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function initializeCheckout() {
      return _ref2.apply(this, arguments);
    };
  }();

  var addToCart = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(variantId, quantity, attributes) {
      var client;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              setLoading(true);
              _context2.next = 3;
              return checkoutClient.addToCart(variantId, parseInt(quantity, 10), attributes ? Object.entries(attributes).map(function (attribute) {
                var attr = {
                  key: attribute[0],
                  value: attribute[1]
                };
                return attr;
              }) : []);

            case 3:
              client = _context2.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x, _x2, _x3) {
      return _ref3.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var removeFromCart = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(variantId) {
      var client;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              setLoading(true);
              _context3.next = 3;
              return checkoutClient.removeFromCart(variantId);

            case 3:
              client = _context3.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x4) {
      return _ref4.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var updateCartItem = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref5 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4(variantId, quantity, attributes) {
      var client;
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              setLoading(true);
              _context4.next = 3;
              return checkoutClient.updateCartItem(variantId, parseInt(quantity, 10), attributes ? Object.entries(attributes).map(function (attribute) {
                var attr = {
                  key: attribute[0],
                  value: attribute[1]
                };
                return attr;
              }) : []);

            case 3:
              client = _context4.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x5, _x6, _x7) {
      return _ref5.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var clearCart = (0, _react.useCallback)(
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee5() {
    var client;
    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            setLoading(true);
            _context5.next = 3;
            return checkoutClient.clearCart();

          case 3:
            client = _context5.sent;
            setCheckout(client.checkout);
            setLoading(false);

          case 6:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  })), [checkoutInitialised]);
  var updateAttributes = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref7 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee6(input) {
      var client;
      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              setLoading(true);
              _context6.next = 3;
              return checkoutClient.updateAttributes(input);

            case 3:
              client = _context6.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function (_x8) {
      return _ref7.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var updateShippingAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref8 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee7(input) {
      var client;
      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              setLoading(true);
              _context7.next = 3;
              return checkoutClient.updateShippingAddress(input);

            case 3:
              client = _context7.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function (_x9) {
      return _ref8.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var updateEmail = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref9 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee8(input) {
      var client;
      return _regenerator["default"].wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              setLoading(true);
              _context8.next = 3;
              return checkoutClient.updateEmail(input);

            case 3:
              client = _context8.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));

    return function (_x10) {
      return _ref9.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var updateCurrency = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref10 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee9(input) {
      var client;
      return _regenerator["default"].wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              setLoading(true);
              _context9.next = 3;
              return checkoutClient.updateCurrency(input);

            case 3:
              client = _context9.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 6:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    return function (_x11) {
      return _ref10.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var applyDiscountCode = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref11 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee10(discountCode) {
      var client;
      return _regenerator["default"].wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              setLoading(true);
              _context10.next = 3;
              return checkoutClient.applyDiscountCode(discountCode);

            case 3:
              client = _context10.sent;

              if (client.checkoutUserErrors) {
                _context10.next = 9;
                break;
              }

              setCheckout(client.checkout);
              setLoading(false);
              _context10.next = 11;
              break;

            case 9:
              setLoading(false);
              return _context10.abrupt("return", client);

            case 11:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));

    return function (_x12) {
      return _ref11.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var getShippingRates = (0, _react.useCallback)(
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee11() {
    var client;
    return _regenerator["default"].wrap(function _callee11$(_context11) {
      while (1) {
        switch (_context11.prev = _context11.next) {
          case 0:
            setLoading(true);
            _context11.next = 3;
            return checkoutClient.getShippingRates();

          case 3:
            client = _context11.sent;
            setCheckout(client.checkout);
            setLoading(false);

          case 6:
          case "end":
            return _context11.stop();
        }
      }
    }, _callee11);
  })), [checkoutInitialised]);
  var checkoutCustomerAssociate = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref13 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee12(accessToken) {
      var client;
      return _regenerator["default"].wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              if (!checkoutInitialised) {
                _context12.next = 7;
                break;
              }

              setLoading(true);
              _context12.next = 4;
              return checkoutClient.checkoutCustomerAssociate(accessToken);

            case 4:
              client = _context12.sent;
              setCheckout(client.checkout);
              setLoading(false);

            case 7:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));

    return function (_x13) {
      return _ref13.apply(this, arguments);
    };
  }(), [checkoutInitialised]);
  var providerValue = (0, _react.useMemo)(function () {
    var _objectSpread2;

    return _objectSpread({}, defaultValues, (_objectSpread2 = {
      checkout: checkout,
      addToCart: addToCart,
      removeFromCart: removeFromCart,
      updateCartItem: updateCartItem,
      clearCart: clearCart
    }, (0, _defineProperty2["default"])(_objectSpread2, "updateCartItem", updateCartItem), (0, _defineProperty2["default"])(_objectSpread2, "updateAttributes", updateAttributes), (0, _defineProperty2["default"])(_objectSpread2, "updateShippingAddress", updateShippingAddress), (0, _defineProperty2["default"])(_objectSpread2, "updateEmail", updateEmail), (0, _defineProperty2["default"])(_objectSpread2, "updateCurrency", updateCurrency), (0, _defineProperty2["default"])(_objectSpread2, "applyDiscountCode", applyDiscountCode), (0, _defineProperty2["default"])(_objectSpread2, "getShippingRates", getShippingRates), (0, _defineProperty2["default"])(_objectSpread2, "checkoutCustomerAssociate", checkoutCustomerAssociate), (0, _defineProperty2["default"])(_objectSpread2, "isLoading", isLoading), _objectSpread2));
  }, [checkout, addToCart, removeFromCart, updateCartItem, clearCart, updateCartItem, updateAttributes, updateShippingAddress, updateEmail, updateCurrency, applyDiscountCode, getShippingRates, checkoutCustomerAssociate, isLoading]);
  return _react["default"].createElement(CheckoutContext.Provider, {
    value: providerValue
  }, children);
};

var _default = (0, _react.memo)(CheckoutProvider);

exports["default"] = _default;