"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _AppliedGiftCardFragment = _interopRequireDefault(require("./AppliedGiftCardFragment"));

var _MailingAddressFragment = _interopRequireDefault(require("./MailingAddressFragment"));

var _VariantWithProductFragment = _interopRequireDefault(require("./VariantWithProductFragment"));

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  fragment CheckoutFragment on Checkout {\n    id\n    ready\n    requiresShipping\n    note\n    paymentDueV2 {\n      amount\n      currencyCode\n    }\n    webUrl\n    orderStatusUrl\n    taxExempt\n    taxesIncluded\n    currencyCode\n    totalTax\n    totalTaxV2 {\n      amount\n      currencyCode\n    }\n    lineItemsSubtotalPrice {\n      amount\n      currencyCode\n    }\n    subtotalPriceV2 {\n      amount\n      currencyCode\n    }\n    totalPriceV2 {\n      amount\n      currencyCode\n    }\n    completedAt\n    createdAt\n    updatedAt\n    email\n    appliedGiftCards {\n      ...AppliedGiftCardFragment\n    }\n    shippingAddress {\n      ...MailingAddressFragment\n    }\n    shippingLine {\n      handle\n      price\n      title\n    }\n    customAttributes {\n      key\n      value\n    }\n    order {\n      id\n      processedAt\n      orderNumber\n      subtotalPriceV2 {\n        amount\n        currencyCode\n      }\n      totalShippingPrice\n      totalShippingPriceV2 {\n        amount\n        currencyCode\n      }\n      totalTaxV2 {\n        amount\n        currencyCode\n      }\n      totalPriceV2 {\n        amount\n        currencyCode\n      }\n      currencyCode\n      totalRefunded\n      totalRefundedV2 {\n        amount\n        currencyCode\n      }\n      customerUrl\n      shippingAddress {\n        ...MailingAddressFragment\n      }\n      lineItems(first: 250) {\n        pageInfo {\n          hasNextPage\n          hasPreviousPage\n        }\n        edges {\n          cursor\n          node {\n            title\n            variant {\n              ...VariantWithProductFragment\n            }\n            quantity\n            customAttributes {\n              key\n              value\n            }\n          }\n        }\n      }\n    }\n    lineItems(first: 250) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          id\n          title\n          variant {\n            ...VariantWithProductFragment\n          }\n          quantity\n          customAttributes {\n            key\n            value\n          }\n          discountAllocations {\n            allocatedAmount {\n              amount\n              currencyCode\n            }\n          }\n        }\n      }\n    }\n    discountApplications(first: 10) {\n      pageInfo {\n        hasNextPage\n        hasPreviousPage\n      }\n      edges {\n        cursor\n        node {\n          allocationMethod\n          targetSelection\n          targetType\n          value {\n            ... on PricingPercentageValue {\n              percentage\n            }\n            ... on MoneyV2 {\n              amount\n              currencyCode\n            }\n          }\n        }\n      }\n    }\n  }\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var CHECKOUT_FRAGMENT = (0, _graphqlTag["default"])(_templateObject(), _AppliedGiftCardFragment["default"], _MailingAddressFragment["default"], _VariantWithProductFragment["default"]);
var _default = CHECKOUT_FRAGMENT;
exports["default"] = _default;