"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CHECKOUT_CUSTOMER_ASSOCIATE = exports.CHECKOUT_DISCOUNT_APPLY = exports.CHECKOUT_EMAIL_UPDATE = exports.CHECKOUT_SHIPPING_ADDRESS_UPDATE = exports.CHECKOUT_ATTRIBUTES_UPDATE = exports.CHECKOUT_LINE_ITEMS_REPLACE = exports.CHECKOUT_CREATE = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _CheckoutFragment = _interopRequireDefault(require("./fragments/CheckoutFragment"));

var _UserErrorFragment = _interopRequireDefault(require("./fragments/UserErrorFragment"));

var _CheckoutUserErrorFragment = _interopRequireDefault(require("./fragments/CheckoutUserErrorFragment"));

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutCustomerAssociateV2(\n    $checkoutId: ID!\n    $customerAccessToken: String!\n  ) {\n    checkoutCustomerAssociateV2(\n      checkoutId: $checkoutId\n      customerAccessToken: $customerAccessToken\n    ) {\n      checkout {\n        ...CheckoutFragment\n      }\n      checkoutUserErrors {\n        ...CheckoutUserErrorFragment\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutDiscountCodeApplyV2(\n    $discountCode: String!\n    $checkoutId: ID!\n  ) {\n    checkoutDiscountCodeApplyV2(\n      discountCode: $discountCode\n      checkoutId: $checkoutId\n    ) {\n      checkout {\n        ...CheckoutFragment\n      }\n      checkoutUserErrors {\n        ...CheckoutUserErrorFragment\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutEmailUpdateV2($email: String!, $checkoutId: ID!) {\n    checkoutEmailUpdateV2(email: $email, checkoutId: $checkoutId) {\n      checkout {\n        ...CheckoutFragment\n      }\n      checkoutUserErrors {\n        ...CheckoutUserErrorFragment\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutShippingAddressUpdateV2(\n    $shippingAddress: MailingAddressInput!\n    $checkoutId: ID!\n  ) {\n    checkoutShippingAddressUpdateV2(\n      shippingAddress: $shippingAddress\n      checkoutId: $checkoutId\n    ) {\n      checkout {\n        ...CheckoutFragment\n      }\n      checkoutUserErrors {\n        ...CheckoutUserErrorFragment\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutAttributesUpdateV2(\n    $checkoutId: ID!\n    $input: CheckoutAttributesUpdateV2Input!\n  ) {\n    checkoutAttributesUpdateV2(checkoutId: $checkoutId, input: $input) {\n      userErrors {\n        ...UserErrorFragment\n      }\n      checkoutUserErrors {\n        ...CheckoutUserErrorFragment\n      }\n      checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n  ", "\n  ", "\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutLineItemsReplace(\n    $checkoutId: ID!\n    $lineItems: [CheckoutLineItemInput!]!\n  ) {\n    checkoutLineItemsReplace(lineItems: $lineItems, checkoutId: $checkoutId) {\n      checkout {\n        ...CheckoutFragment\n      }\n      userErrors {\n        code\n        field\n        message\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation checkoutCreate($input: CheckoutCreateInput!) {\n    checkoutCreate(input: $input) {\n      checkout {\n        id\n        ...CheckoutFragment\n      }\n      checkoutUserErrors {\n        code\n        field\n        message\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var CHECKOUT_CREATE = (0, _graphqlTag["default"])(_templateObject(), _CheckoutFragment["default"]);
exports.CHECKOUT_CREATE = CHECKOUT_CREATE;
var CHECKOUT_LINE_ITEMS_REPLACE = (0, _graphqlTag["default"])(_templateObject2(), _CheckoutFragment["default"]);
exports.CHECKOUT_LINE_ITEMS_REPLACE = CHECKOUT_LINE_ITEMS_REPLACE;
var CHECKOUT_ATTRIBUTES_UPDATE = (0, _graphqlTag["default"])(_templateObject3(), _CheckoutFragment["default"], _UserErrorFragment["default"], _CheckoutUserErrorFragment["default"]);
exports.CHECKOUT_ATTRIBUTES_UPDATE = CHECKOUT_ATTRIBUTES_UPDATE;
var CHECKOUT_SHIPPING_ADDRESS_UPDATE = (0, _graphqlTag["default"])(_templateObject4(), _CheckoutFragment["default"], _CheckoutUserErrorFragment["default"]);
exports.CHECKOUT_SHIPPING_ADDRESS_UPDATE = CHECKOUT_SHIPPING_ADDRESS_UPDATE;
var CHECKOUT_EMAIL_UPDATE = (0, _graphqlTag["default"])(_templateObject5(), _CheckoutFragment["default"], _CheckoutUserErrorFragment["default"]);
exports.CHECKOUT_EMAIL_UPDATE = CHECKOUT_EMAIL_UPDATE;
var CHECKOUT_DISCOUNT_APPLY = (0, _graphqlTag["default"])(_templateObject6(), _CheckoutFragment["default"], _CheckoutUserErrorFragment["default"]);
exports.CHECKOUT_DISCOUNT_APPLY = CHECKOUT_DISCOUNT_APPLY;
var CHECKOUT_CUSTOMER_ASSOCIATE = (0, _graphqlTag["default"])(_templateObject7(), _CheckoutFragment["default"], _CheckoutUserErrorFragment["default"]);
exports.CHECKOUT_CUSTOMER_ASSOCIATE = CHECKOUT_CUSTOMER_ASSOCIATE;