"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FETCH_SHIPPING_RATES = exports.FETCH_CHECKOUT = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _CheckoutFragment = _interopRequireDefault(require("./fragments/CheckoutFragment"));

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  query FETCH_SHIPPING_RATES($id: ID!) {\n    node(id: $id) {\n      ... on Checkout {\n        ...CheckoutFragment\n        availableShippingRates {\n          ready\n          shippingRates {\n            handle\n            priceV2 {\n              amount\n              currencyCode\n            }\n            title\n          }\n        }\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  query FETCH_CHECKOUT($checkoutId: ID!) {\n    node(id: $checkoutId) {\n      ... on Checkout {\n        ...CheckoutFragment\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var FETCH_CHECKOUT = (0, _graphqlTag["default"])(_templateObject(), _CheckoutFragment["default"]);
exports.FETCH_CHECKOUT = FETCH_CHECKOUT;
var FETCH_SHIPPING_RATES = (0, _graphqlTag["default"])(_templateObject2(), _CheckoutFragment["default"]);
exports.FETCH_SHIPPING_RATES = FETCH_SHIPPING_RATES;