"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.NextContext = void 0;

var _react = _interopRequireWildcard(require("react"));

var _apollo = _interopRequireDefault(require("../apollo"));

var _authentication = _interopRequireDefault(require("../authentication"));

var _checkout = _interopRequireDefault(require("../checkout"));

var _database = _interopRequireDefault(require("../database"));

var _service = require("../firebase/service");

var _context = _interopRequireDefault(require("../functions/context"));

var _shopify = require("../shopify");

var NextContext = _react["default"].createContext(null);

exports.NextContext = NextContext;

var NextProvider = function NextProvider(_ref) {
  var children = _ref.children,
      shopifyConfigs = _ref.shopifyConfigs,
      databaseConfig = _ref.databaseConfig,
      authConfig = _ref.authConfig,
      functionsGraphQLAPI = _ref.functionsGraphQLAPI,
      shopifyApiVersion = _ref.shopifyApiVersion;
  var firebaseApp = (0, _react.useRef)((0, _service.initFirebaseApp)(databaseConfig)).current;
  return _react["default"].createElement(_authentication["default"], {
    authConfig: authConfig,
    firebaseApp: firebaseApp
  }, _react["default"].createElement(_context["default"], {
    shopifyConfigs: shopifyConfigs,
    uri: functionsGraphQLAPI
  }, function (shopifyConfig) {
    return _react["default"].createElement(_apollo["default"], {
      shopName: shopifyConfig.shopName,
      accessToken: shopifyConfig.storefrontAccessToken,
      apiVersion: shopifyApiVersion
    }, _react["default"].createElement(_shopify.ShopifyCustomerProvider, {
      shopName: shopifyConfig.shopName,
      accessToken: shopifyConfig.storefrontAccessToken,
      apiVersion: shopifyApiVersion
    }, _react["default"].createElement(_checkout["default"], {
      shopName: shopifyConfig.shopName,
      accessToken: shopifyConfig.storefrontAccessToken,
      apiVersion: shopifyApiVersion
    }, _react["default"].createElement(_database["default"], {
      firebaseApp: firebaseApp
    }, children))));
  }));
};

var _default = (0, _react.memo)(NextProvider);

exports["default"] = _default;