"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var WISHLISTS = "wishlists";
var SHIPPING = "shippingAddresses";
var DEFAULT_WISHLIST_NAMES = {
  product: "favouriteProducts",
  other: "favouriteItems"
};
var WISHLIST_ITEMS = "items";

var Database = function Database(firebaseApp) {
  var _this = this;

  (0, _classCallCheck2["default"])(this, Database);
  (0, _defineProperty2["default"])(this, "user", function (uid) {
    return _this.db.doc("users/".concat(uid));
  });
  (0, _defineProperty2["default"])(this, "users", function () {
    return _this.db.collection("users");
  });
  (0, _defineProperty2["default"])(this, "collectionSubscribe", function (collectionPath, cb) {
    var unsubscribe = _this.db.collection(collectionPath).onSnapshot(function (_ref) {
      var docs = _ref.docs;
      var list = docs.map(function (doc) {
        return doc.data();
      });
      cb(list);
    });

    return unsubscribe;
  });
  (0, _defineProperty2["default"])(this, "docSubscribe", function (docPath, cb) {
    var unsubscribe = _this.db.doc(docPath).onSnapshot(function (doc) {
      var data = doc.data();
      cb(data);
    });

    return unsubscribe;
  });
  (0, _defineProperty2["default"])(this, "addUserData", function (_ref2) {
    var userId = _ref2.userId,
        data = _ref2.data;
    return _this.users().doc(userId).set(_objectSpread({}, data), {
      merge: true
    });
  });
  (0, _defineProperty2["default"])(this, "wishlistSubscribe", function (uid) {
    var wishlistName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_WISHLIST_NAMES.product;
    var cb = arguments.length > 2 ? arguments[2] : undefined;

    var unsubscribe = _this.users().doc(uid).collection(WISHLISTS).doc(wishlistName).collection(WISHLIST_ITEMS).onSnapshot(function (data) {
      var list = data.docs.map(function (doc) {
        return doc.data();
      });
      cb(list);
    });

    return unsubscribe;
  });
  (0, _defineProperty2["default"])(this, "getAllWishlistNames", function (uid, cb) {
    var unsubscribe = _this.users().doc(uid).onSnapshot(function (snapshot) {
      var data = snapshot.data();
      var wishlistCollections = data.wishlistCollections;
      cb(wishlistCollections);
    });

    return unsubscribe;
  });
  (0, _defineProperty2["default"])(this, "addToWishlist",
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(userId, item) {
      var wishlistName,
          batch,
          userRef,
          wishlistRef,
          wishlistItemRef,
          _args = arguments;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              wishlistName = _args.length > 2 && _args[2] !== undefined ? _args[2] : DEFAULT_WISHLIST_NAMES.product;
              batch = _this.db.batch();
              userRef = _this.users().doc(userId);
              wishlistRef = userRef.collection(WISHLISTS).doc(wishlistName);
              batch.set(wishlistRef, {
                userId: userId
              }, {
                merge: true
              });
              wishlistItemRef = wishlistRef.collection(WISHLIST_ITEMS).doc(item.id);
              batch.set(wishlistItemRef, {
                item: _objectSpread({}, item),
                createdAt: _this.firebaseApp.firestore.FieldValue.serverTimestamp(),
                userId: userId
              }, {
                merge: true
              });
              batch.update(userRef, {
                wishlistCollections: _this.firebaseApp.firestore.FieldValue.arrayUnion(wishlistName)
              });
              return _context.abrupt("return", batch.commit());

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref3.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "removeFromWishlist",
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(userId, itemId) {
      var wishlistName,
          _args2 = arguments;
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              wishlistName = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : DEFAULT_WISHLIST_NAMES.product;
              return _context2.abrupt("return", _this.users().doc(userId).collection(WISHLISTS).doc(wishlistName).collection(WISHLIST_ITEMS).doc(itemId)["delete"]());

            case 2:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x3, _x4) {
      return _ref4.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "shareWishlist",
  /*#__PURE__*/
  function () {
    var _ref5 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3(userId) {
      var wishlistName,
          _args3 = arguments;
      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              wishlistName = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : DEFAULT_WISHLIST_NAMES.product;
              return _context3.abrupt("return", _this.users().doc(userId).collection(WISHLISTS).doc(wishlistName).set({
                "public": true
              }, {
                merge: true
              }));

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x5) {
      return _ref5.apply(this, arguments);
    };
  }());
  (0, _defineProperty2["default"])(this, "shippingAddressesSubscribe", function (userId, cb) {
    var unsubscribe = _this.users().doc(userId).collection(SHIPPING).orderBy("createdAt", "desc").onSnapshot(function (data) {
      var docs = data.docs;
      _this.addresses = docs.map(function (doc) {
        return _objectSpread({}, doc.data(), {
          id: doc.id
        });
      });
      cb(_this.addresses);
    });

    return unsubscribe;
  });
  (0, _defineProperty2["default"])(this, "saveShippingAddress", function (userId, addressDetails) {
    var isPrimary = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    return _this.users().doc(userId).collection(SHIPPING).add({
      address: addressDetails,
      isPrimary: isPrimary,
      createdAt: _this.firebaseApp.firestore.FieldValue.serverTimestamp(),
      userId: userId
    });
  });
  (0, _defineProperty2["default"])(this, "updateShippingAddress", function (_ref6) {
    var userId = _ref6.userId,
        addressId = _ref6.addressId,
        addressDetails = _ref6.addressDetails,
        _ref6$isPrimary = _ref6.isPrimary,
        isPrimary = _ref6$isPrimary === void 0 ? false : _ref6$isPrimary;
    return _this.users().doc(userId).collection(SHIPPING).doc(addressId).update(_objectSpread({}, addressDetails && {
      address: _objectSpread({}, addressDetails)
    }, {
      isPrimary: isPrimary,
      updatedAt: _this.firebaseApp.firestore.FieldValue.serverTimestamp()
    }));
  });
  (0, _defineProperty2["default"])(this, "deleteShippingAddress", function (_ref7) {
    var userId = _ref7.userId,
        addressId = _ref7.addressId;
    return _this.users().doc(userId).collection(SHIPPING).doc(addressId)["delete"]();
  });
  this.firebaseApp = firebaseApp;

  if (typeof window !== "undefined") {
    this.db = firebaseApp.firestore();
  }

  this.allWishlists = [];
  this.addresses = [];
};

var _default = Database;
exports["default"] = _default;