"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ShopifyCustomerContext = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _customer = _interopRequireDefault(require("./customer"));

var _context15 = require("../../functions/context");

var _context16 = require("../../authentication/context");

var ShopifyCustomerContext = _react["default"].createContext(null);

exports.ShopifyCustomerContext = ShopifyCustomerContext;
var shopifyCustomerClient = new _customer["default"]();

var ShopifyCustomerProvider = function ShopifyCustomerProvider(_ref) {
  var children = _ref.children,
      shopName = _ref.shopName,
      accessToken = _ref.accessToken,
      apiVersion = _ref.apiVersion;

  if (!shopifyCustomerClient.client) {
    shopifyCustomerClient.initialize({
      shopName: shopName,
      accessToken: accessToken,
      apiVersion: apiVersion
    });
  }

  var authContext = _react["default"].useContext(_context16.AuthContext);

  var functionsContext = _react["default"].useContext(_context15.FunctionsContext);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isLoading = _useState2[0],
      setLoading = _useState2[1];

  var wrapClientMethod = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref2 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(clientMethod) {
      var _len,
          args,
          _key,
          _args = arguments;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setLoading(true);

              for (_len = _args.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = _args[_key];
              }

              _context.next = 4;
              return clientMethod.apply(void 0, args);

            case 4:
              setLoading(false);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }(), []);
  var refreshCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2() {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            return _context2.abrupt("return", wrapClientMethod(shopifyCustomerClient.refreshInternalCustomer));

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })), []);

  var createCustomer =
  /*#__PURE__*/
  function () {
    var _ref4 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3() {
      var _len2,
          args,
          _key2,
          _args3 = arguments;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              for (_len2 = _args3.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                args[_key2] = _args3[_key2];
              }

              return _context3.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerCreate].concat(args)));

            case 2:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function createCustomer() {
      return _ref4.apply(this, arguments);
    };
  }();

  var updateCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref5 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee4() {
      var _len3,
          args,
          _key3,
          _args4 = arguments;

      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              for (_len3 = _args4.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                args[_key3] = _args4[_key3];
              }

              return _context4.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerUpdate].concat(args)));

            case 2:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function () {
      return _ref5.apply(this, arguments);
    };
  }(), []);

  var authenticateCustomer =
  /*#__PURE__*/
  function () {
    var _ref6 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee5() {
      var _len4,
          args,
          _key4,
          _args5 = arguments;

      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              for (_len4 = _args5.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
                args[_key4] = _args5[_key4];
              }

              return _context5.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerAuthenticate].concat(args)));

            case 2:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function authenticateCustomer() {
      return _ref6.apply(this, arguments);
    };
  }();

  var createCustomerAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref7 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee6() {
      var _len5,
          args,
          _key5,
          _args6 = arguments;

      return _regenerator["default"].wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              for (_len5 = _args6.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
                args[_key5] = _args6[_key5];
              }

              return _context6.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerAddressCreate].concat(args)));

            case 2:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6);
    }));

    return function () {
      return _ref7.apply(this, arguments);
    };
  }(), []);
  var deleteCustomerAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref8 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee7() {
      var _len6,
          args,
          _key6,
          _args7 = arguments;

      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              for (_len6 = _args7.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
                args[_key6] = _args7[_key6];
              }

              return _context7.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerAddressDelete].concat(args)));

            case 2:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7);
    }));

    return function () {
      return _ref8.apply(this, arguments);
    };
  }(), []);
  var updateCustomerAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref9 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee8() {
      var _len7,
          args,
          _key7,
          _args8 = arguments;

      return _regenerator["default"].wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              for (_len7 = _args8.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
                args[_key7] = _args8[_key7];
              }

              return _context8.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerAddressUpdate].concat(args)));

            case 2:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8);
    }));

    return function () {
      return _ref9.apply(this, arguments);
    };
  }(), []);
  var updateCustomerDefaultAddress = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref10 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee9() {
      var _len8,
          args,
          _key8,
          _args9 = arguments;

      return _regenerator["default"].wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              for (_len8 = _args9.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
                args[_key8] = _args9[_key8];
              }

              return _context9.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerDefaultAddressUpdate].concat(args)));

            case 2:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    return function () {
      return _ref10.apply(this, arguments);
    };
  }(), []);
  var recoverPasswordCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref11 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee10() {
      var _len9,
          args,
          _key9,
          _args10 = arguments;

      return _regenerator["default"].wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              for (_len9 = _args10.length, args = new Array(_len9), _key9 = 0; _key9 < _len9; _key9++) {
                args[_key9] = _args10[_key9];
              }

              return _context10.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerRecoverPassword].concat(args)));

            case 2:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));

    return function () {
      return _ref11.apply(this, arguments);
    };
  }(), []);
  var resetPasswordCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref12 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee11() {
      var _len10,
          args,
          _key10,
          _args11 = arguments;

      return _regenerator["default"].wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              for (_len10 = _args11.length, args = new Array(_len10), _key10 = 0; _key10 < _len10; _key10++) {
                args[_key10] = _args11[_key10];
              }

              return _context11.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerResetPassword].concat(args)));

            case 2:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11);
    }));

    return function () {
      return _ref12.apply(this, arguments);
    };
  }(), []);
  var resetPasswordByUrlCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref13 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee12() {
      var _len11,
          args,
          _key11,
          _args12 = arguments;

      return _regenerator["default"].wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              for (_len11 = _args12.length, args = new Array(_len11), _key11 = 0; _key11 < _len11; _key11++) {
                args[_key11] = _args12[_key11];
              }

              return _context12.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerResetPasswordByUrl].concat(args)));

            case 2:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12);
    }));

    return function () {
      return _ref13.apply(this, arguments);
    };
  }(), []);
  var accountActivateCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref14 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee13() {
      var _len12,
          args,
          _key12,
          _args13 = arguments;

      return _regenerator["default"].wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              for (_len12 = _args13.length, args = new Array(_len12), _key12 = 0; _key12 < _len12; _key12++) {
                args[_key12] = _args13[_key12];
              }

              return _context13.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerActivateAccount].concat(args)));

            case 2:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13);
    }));

    return function () {
      return _ref14.apply(this, arguments);
    };
  }(), []);
  var accountActivateByUrlCustomer = (0, _react.useCallback)(
  /*#__PURE__*/
  function () {
    var _ref15 = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee14() {
      var _len13,
          args,
          _key13,
          _args14 = arguments;

      return _regenerator["default"].wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              for (_len13 = _args14.length, args = new Array(_len13), _key13 = 0; _key13 < _len13; _key13++) {
                args[_key13] = _args14[_key13];
              }

              return _context14.abrupt("return", wrapClientMethod.apply(void 0, [shopifyCustomerClient.customerActivateAccountByUrl].concat(args)));

            case 2:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14);
    }));

    return function () {
      return _ref15.apply(this, arguments);
    };
  }(), []);
  (0, _react.useEffect)(function () {
    if (!isLoading) {
      /** if we there's a customerAccessToken available and we don't have it: copy it */
      if (functionsContext.customerAccessToken && !shopifyCustomerClient.customerAccessToken) {
        shopifyCustomerClient.setInternalCustomerAccessToken(functionsContext.customerAccessToken.customerAccessTokenCreate.accessToken);
      }
      /** if we have a Firebase User and customerAccessToken but "stale" Shopify Customer: refresh our Shopify Customer */


      if (!shopifyCustomerClient.customerDataFresh && authContext.authUser && shopifyCustomerClient.customerAccessToken) {
        refreshCustomer();
      }
    }
  });
  var providerValue = (0, _react.useMemo)(function () {
    return {
      customerData: shopifyCustomerClient.customerData,
      createCustomer: createCustomer,
      updateCustomer: updateCustomer,
      authenticateCustomer: authenticateCustomer,
      createCustomerAddress: createCustomerAddress,
      updateCustomerAddress: updateCustomerAddress,
      deleteCustomerAddress: deleteCustomerAddress,
      updateCustomerDefaultAddress: updateCustomerDefaultAddress,
      recoverPasswordCustomer: recoverPasswordCustomer,
      resetPasswordCustomer: resetPasswordCustomer,
      resetPasswordByUrlCustomer: resetPasswordByUrlCustomer,
      accountActivateCustomer: accountActivateCustomer,
      accountActivateByUrlCustomer: accountActivateByUrlCustomer,
      isLoading: isLoading
    };
  }, [shopifyCustomerClient, createCustomer, updateCustomer, authenticateCustomer, createCustomerAddress, updateCustomerAddress, deleteCustomerAddress, updateCustomerDefaultAddress, recoverPasswordCustomer, resetPasswordCustomer, resetPasswordByUrlCustomer, accountActivateCustomer, accountActivateByUrlCustomer, isLoading]);
  return _react["default"].createElement(ShopifyCustomerContext.Provider, {
    value: providerValue
  }, children);
};

var _default = (0, _react.memo)(ShopifyCustomerProvider);

exports["default"] = _default;