"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ShopifyCustomer = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _store = _interopRequireDefault(require("store/dist/store.modern"));

var _ApolloClient = require("../../apollo/ApolloClient");

var _queries = require("./graphql/queries");

var _mutations = require("./graphql/mutations");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var ShopifyCustomer =
/*#__PURE__*/
function () {
  function ShopifyCustomer() {
    var _this = this;

    (0, _classCallCheck2["default"])(this, ShopifyCustomer);
    (0, _defineProperty2["default"])(this, "customerDataFresh", false);
    (0, _defineProperty2["default"])(this, "customerAccessToken", _store["default"].get("next:access_token"));
    (0, _defineProperty2["default"])(this, "customerData", _store["default"].get("next:shopify_customer_data") ? _store["default"].get("next:shopify_customer_data") : "null");
    (0, _defineProperty2["default"])(this, "setInternalCustomerAccessToken", function (customerAccessToken) {
      _store["default"].set("next:access_token", customerAccessToken);

      _this.customerAccessToken = customerAccessToken;
    });
    (0, _defineProperty2["default"])(this, "setInternalCustomer",
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(customerData) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _store["default"].set("next:shopify_customer_data", customerData);

                _this.customerData = customerData;

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "refreshInternalCustomer",
    /*#__PURE__*/
    (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2() {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = _this;
              _context2.next = 3;
              return _this.getCustomer();

            case 3:
              _context2.t1 = _context2.sent;

              _context2.t0.setInternalCustomer.call(_context2.t0, _context2.t1);

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    })));
    (0, _defineProperty2["default"])(this, "getCustomer",
    /*#__PURE__*/
    (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3() {
      var _ref4, customer, formattedCustomer;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _this.customerDataFresh = true;
              _context3.next = 3;
              return _this.client.query({
                query: _queries.CUSTOMER,
                variables: {
                  customerAccessToken: _this.customerAccessToken
                },
                fetchPolicy: "no-cache"
              });

            case 3:
              _ref4 = _context3.sent;
              customer = _ref4.data.customer;
              formattedCustomer = _objectSpread({}, customer, {
                addresses: customer.addresses.edges.map(function (edge) {
                  return _objectSpread({}, edge.node, {
                    isPrimary: edge.node.id === customer.defaultAddress.id
                  });
                })
              });
              return _context3.abrupt("return", formattedCustomer);

            case 7:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    })));
    (0, _defineProperty2["default"])(this, "customerCreate",
    /*#__PURE__*/
    function () {
      var _ref5 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee4(input) {
        var _ref6, customer;

        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_CREATE,
                  variables: {
                    input: input
                  }
                });

              case 2:
                _ref6 = _context4.sent;
                customer = _ref6.data.customerCreate.customer;
                _context4.next = 6;
                return _this.customerAuthenticate(input);

              case 6:
                return _context4.abrupt("return", _this.customerData);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function (_x2) {
        return _ref5.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerUpdate",
    /*#__PURE__*/
    function () {
      var _ref7 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee5(customerInput) {
        var _ref8, customer;

        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_UPDATE,
                  variables: {
                    customerAccessToken: _this.customerAccessToken,
                    customer: customerInput
                  }
                });

              case 2:
                _ref8 = _context5.sent;
                customer = _ref8.data.customerUpdate.customer;
                _context5.next = 6;
                return _this.refreshInternalCustomer();

              case 6:
                return _context5.abrupt("return", _this.customerData);

              case 7:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      return function (_x3) {
        return _ref7.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerAuthenticate",
    /*#__PURE__*/
    function () {
      var _ref9 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee6(input) {
        var _ref10, accessToken;

        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ACCESS_TOKEN_CREATE,
                  variables: {
                    input: {
                      email: input.email,
                      password: input.password
                    }
                  }
                });

              case 2:
                _ref10 = _context6.sent;
                accessToken = _ref10.data.customerAccessTokenCreate.customerAccessToken.accessToken;

                _this.setInternalCustomerAccessToken(accessToken);

                _context6.next = 7;
                return _this.refreshInternalCustomer();

              case 7:
                return _context6.abrupt("return", _this.customerData);

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      return function (_x4) {
        return _ref9.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerAddressCreate",
    /*#__PURE__*/
    function () {
      var _ref11 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee7(address, primary) {
        var _ref12, customerAddress;

        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ADDRESS_CREATE,
                  variables: {
                    customerAccessToken: _this.customerAccessToken,
                    address: address
                  }
                });

              case 2:
                _ref12 = _context7.sent;
                customerAddress = _ref12.data.customerAddressCreate.customerAddress;

                if (!primary) {
                  _context7.next = 9;
                  break;
                }

                _context7.next = 7;
                return _this.customerDefaultAddressUpdate(customerAddress.id);

              case 7:
                _context7.next = 11;
                break;

              case 9:
                _context7.next = 11;
                return _this.refreshInternalCustomer();

              case 11:
                return _context7.abrupt("return", customerAddress);

              case 12:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7);
      }));

      return function (_x5, _x6) {
        return _ref11.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerAddressDelete",
    /*#__PURE__*/
    function () {
      var _ref13 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee8(id) {
        var _ref14, deletedCustomerAddressId;

        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ADDRESS_DELETE,
                  variables: {
                    customerAccessToken: _this.customerAccessToken,
                    id: id
                  }
                });

              case 2:
                _ref14 = _context8.sent;
                deletedCustomerAddressId = _ref14.data.customerAddressDelete.deletedCustomerAddressId;
                _context8.next = 6;
                return _this.refreshInternalCustomer();

              case 6:
                return _context8.abrupt("return", deletedCustomerAddressId);

              case 7:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8);
      }));

      return function (_x7) {
        return _ref13.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerAddressUpdate",
    /*#__PURE__*/
    function () {
      var _ref15 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee9(id, address, primary) {
        var _ref16, customerAddress;

        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ADDRESS_UPDATE,
                  variables: {
                    customerAccessToken: _this.customerAccessToken,
                    id: id,
                    address: address
                  }
                });

              case 2:
                _ref16 = _context9.sent;
                customerAddress = _ref16.data.customerAddressUpdate.customerAddress;

                if (!primary) {
                  _context9.next = 9;
                  break;
                }

                _context9.next = 7;
                return _this.customerDefaultAddressUpdate(customerAddress.id);

              case 7:
                _context9.next = 11;
                break;

              case 9:
                _context9.next = 11;
                return _this.refreshInternalCustomer();

              case 11:
                return _context9.abrupt("return", customerAddress);

              case 12:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      return function (_x8, _x9, _x10) {
        return _ref15.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerDefaultAddressUpdate",
    /*#__PURE__*/
    function () {
      var _ref17 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee10(id) {
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_DEFAULT_ADDRESS_UPDATE,
                  variables: {
                    customerAccessToken: _this.customerAccessToken,
                    addressId: id
                  }
                });

              case 2:
                _context10.next = 4;
                return _this.refreshInternalCustomer();

              case 4:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      return function (_x11) {
        return _ref17.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerRecoverPassword",
    /*#__PURE__*/
    function () {
      var _ref18 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee11(email) {
        return _regenerator["default"].wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                _context11.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_RECOVER,
                  variables: {
                    email: email
                  }
                });

              case 2:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11);
      }));

      return function (_x12) {
        return _ref18.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerResetPassword",
    /*#__PURE__*/
    function () {
      var _ref19 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee12(id, resetToken, password) {
        var _ref20, _ref20$data$customerR, customer, customerAccessToken;

        return _regenerator["default"].wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_RESET,
                  variables: {
                    id: id,
                    input: {
                      password: password,
                      resetToken: resetToken
                    }
                  }
                });

              case 2:
                _ref20 = _context12.sent;
                _ref20$data$customerR = _ref20.data.customerReset;
                customer = _ref20$data$customerR.customer;
                customerAccessToken = _ref20$data$customerR.customerAccessToken;

              case 6:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12);
      }));

      return function (_x13, _x14, _x15) {
        return _ref19.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerResetPasswordByUrl",
    /*#__PURE__*/
    function () {
      var _ref21 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee13(resetUrl, password) {
        var _ref22, _ref22$data$customerR, customer, customerAccessToken;

        return _regenerator["default"].wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_RESET_BY_URL,
                  variables: {
                    resetUrl: resetUrl,
                    password: password
                  }
                });

              case 2:
                _ref22 = _context13.sent;
                _ref22$data$customerR = _ref22.data.customerReset;
                customer = _ref22$data$customerR.customer;
                customerAccessToken = _ref22$data$customerR.customerAccessToken;

              case 6:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13);
      }));

      return function (_x16, _x17) {
        return _ref21.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerActivateAccount",
    /*#__PURE__*/
    function () {
      var _ref23 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee14(id, activationToken, password) {
        var _ref24, _ref24$data$customerA, customer, customerAccessToken;

        return _regenerator["default"].wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                _context14.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ACTIVATE,
                  variables: {
                    id: id,
                    input: {
                      activationToken: activationToken,
                      password: password
                    }
                  }
                });

              case 2:
                _ref24 = _context14.sent;
                _ref24$data$customerA = _ref24.data.customerActivate;
                customer = _ref24$data$customerA.customer;
                customerAccessToken = _ref24$data$customerA.customerAccessToken;

              case 6:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14);
      }));

      return function (_x18, _x19, _x20) {
        return _ref23.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])(this, "customerActivateAccountByUrl",
    /*#__PURE__*/
    function () {
      var _ref25 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee15(activationUrl, password) {
        var _ref26, _ref26$data$customerA, customer, customerAccessToken;

        return _regenerator["default"].wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                _context15.next = 2;
                return _this.client.mutate({
                  mutation: _mutations.CUSTOMER_ACTIVATE_BY_URL,
                  variables: {
                    activationUrl: activationUrl,
                    password: password
                  }
                });

              case 2:
                _ref26 = _context15.sent;
                _ref26$data$customerA = _ref26.data.customerActivate;
                customer = _ref26$data$customerA.customer;
                customerAccessToken = _ref26$data$customerA.customerAccessToken;

              case 6:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15);
      }));

      return function (_x21, _x22) {
        return _ref25.apply(this, arguments);
      };
    }());
  }

  (0, _createClass2["default"])(ShopifyCustomer, [{
    key: "initialize",
    value: function initialize(config) {
      var client = (0, _ApolloClient.createApolloClient)({
        uri: "https://".concat(config.shopName, ".myshopify.com/api/").concat(config.apiVersion ? "".concat(config.apiVersion, "/") : "", "graphql.json"),
        headers: {
          "X-Shopify-Storefront-Access-Token": config.accessToken
        }
      });
      this.client = client;
    }
  }, {
    key: "reset",
    value: function reset() {
      this.customerDataFresh = false;
      this.customerAccessToken = null;
      this.customerData = null;

      for (var _i = 0, _arr = ["next:shopify_customer_data", "next:access_token"]; _i < _arr.length; _i++) {
        var key = _arr[_i];

        _store["default"].remove(key);
      }
    }
  }]);
  return ShopifyCustomer;
}();

exports.ShopifyCustomer = ShopifyCustomer;
var _default = ShopifyCustomer;
exports["default"] = _default;