"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CUSTOMER_ACTIVATE_BY_URL = exports.CUSTOMER_ACTIVATE = exports.CUSTOMER_RESET_BY_URL = exports.CUSTOMER_RESET = exports.CUSTOMER_RECOVER = exports.CUSTOMER_DEFAULT_ADDRESS_UPDATE = exports.CUSTOMER_ADDRESS_UPDATE = exports.CUSTOMER_ADDRESS_DELETE = exports.CUSTOMER_ADDRESS_CREATE = exports.CUSTOMER_UPDATE = exports.CUSTOMER_CREATE = exports.CUSTOMER_ACCESS_TOKEN_CREATE = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _graphqlTag = _interopRequireDefault(require("graphql-tag"));

var _MailingAddressFragment = _interopRequireDefault(require("./fragments/MailingAddressFragment"));

var _CustomerUserErrorFragment = _interopRequireDefault(require("./fragments/CustomerUserErrorFragment"));

function _templateObject12() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerActivateByUrl($activationUrl: URL!, $password: String!) {\n    customerActivateByUrl(activationUrl: $activationUrl, password: $password) {\n      customer {\n        id\n      }\n      customerAccessToken {\n        accessToken\n        expiresAt\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerActivate($id: ID!, $input: CustomerActivateInput!) {\n    customerActivate(id: $id, input: $input) {\n      customer {\n        id\n      }\n      customerAccessToken {\n        accessToken\n        expiresAt\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerResetByUrl($resetUrl: URL!, $password: String!) {\n    customerResetByUrl(resetUrl: $resetUrl, password: $password) {\n      customer {\n        id\n      }\n      customerAccessToken {\n        accessToken\n        expiresAt\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerReset($id: ID!, $input: CustomerResetInput!) {\n    customerReset(id: $id, input: $input) {\n      customer {\n        id\n      }\n      customerAccessToken {\n        accessToken\n        expiresAt\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerRecover($email: String!) {\n    customerRecover(email: $email) {\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerDefaultAddressUpdate(\n    $customerAccessToken: String!\n    $addressId: ID!\n  ) {\n    customerDefaultAddressUpdate(\n      customerAccessToken: $customerAccessToken\n      addressId: $addressId\n    ) {\n      customer {\n        id\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerAddressUpdate(\n    $customerAccessToken: String!\n    $id: ID!\n    $address: MailingAddressInput!\n  ) {\n    customerAddressUpdate(\n      customerAccessToken: $customerAccessToken\n      id: $id\n      address: $address\n    ) {\n      customerAddress {\n        ...MAILING_ADDRESS_FRAGMENT\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerAddressDelete($customerAccessToken: String!, $id: ID!) {\n    customerAddressDelete(customerAccessToken: $customerAccessToken, id: $id) {\n      deletedCustomerAddressId\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerAddressCreate(\n    $customerAccessToken: String!\n    $address: MailingAddressInput!\n  ) {\n    customerAddressCreate(\n      customerAccessToken: $customerAccessToken\n      address: $address\n    ) {\n      customerAddress {\n        ...MAILING_ADDRESS_FRAGMENT\n      }\n      customerUserErrors {\n        ...CUSTOMER_USER_ERROR_FRAGMENT\n      }\n    }\n  }\n  ", "\n  ", "\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerUpdate(\n    $customerAccessToken: String!\n    $customer: CustomerUpdateInput!\n  ) {\n    customerUpdate(\n      customerAccessToken: $customerAccessToken\n      customer: $customer\n    ) {\n      customer {\n        id\n      }\n    }\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerCreate($input: CustomerCreateInput!) {\n    customerCreate(input: $input) {\n      customer {\n        id\n      }\n    }\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = (0, _taggedTemplateLiteral2["default"])(["\n  mutation customerAccessTokenCreate($input: CustomerAccessTokenCreateInput!) {\n    customerAccessTokenCreate(input: $input) {\n      customerAccessToken {\n        accessToken\n        expiresAt\n      }\n    }\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

var CUSTOMER_ACCESS_TOKEN_CREATE = (0, _graphqlTag["default"])(_templateObject());
exports.CUSTOMER_ACCESS_TOKEN_CREATE = CUSTOMER_ACCESS_TOKEN_CREATE;
var CUSTOMER_CREATE = (0, _graphqlTag["default"])(_templateObject2());
exports.CUSTOMER_CREATE = CUSTOMER_CREATE;
var CUSTOMER_UPDATE = (0, _graphqlTag["default"])(_templateObject3());
exports.CUSTOMER_UPDATE = CUSTOMER_UPDATE;
var CUSTOMER_ADDRESS_CREATE = (0, _graphqlTag["default"])(_templateObject4(), _MailingAddressFragment["default"], _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_ADDRESS_CREATE = CUSTOMER_ADDRESS_CREATE;
var CUSTOMER_ADDRESS_DELETE = (0, _graphqlTag["default"])(_templateObject5(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_ADDRESS_DELETE = CUSTOMER_ADDRESS_DELETE;
var CUSTOMER_ADDRESS_UPDATE = (0, _graphqlTag["default"])(_templateObject6(), _MailingAddressFragment["default"], _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_ADDRESS_UPDATE = CUSTOMER_ADDRESS_UPDATE;
var CUSTOMER_DEFAULT_ADDRESS_UPDATE = (0, _graphqlTag["default"])(_templateObject7(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_DEFAULT_ADDRESS_UPDATE = CUSTOMER_DEFAULT_ADDRESS_UPDATE;
var CUSTOMER_RECOVER = (0, _graphqlTag["default"])(_templateObject8(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_RECOVER = CUSTOMER_RECOVER;
var CUSTOMER_RESET = (0, _graphqlTag["default"])(_templateObject9(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_RESET = CUSTOMER_RESET;
var CUSTOMER_RESET_BY_URL = (0, _graphqlTag["default"])(_templateObject10(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_RESET_BY_URL = CUSTOMER_RESET_BY_URL;
var CUSTOMER_ACTIVATE = (0, _graphqlTag["default"])(_templateObject11(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_ACTIVATE = CUSTOMER_ACTIVATE;
var CUSTOMER_ACTIVATE_BY_URL = (0, _graphqlTag["default"])(_templateObject12(), _CustomerUserErrorFragment["default"]);
exports.CUSTOMER_ACTIVATE_BY_URL = CUSTOMER_ACTIVATE_BY_URL;